package sample.activity;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import com.poscoict.glueframework.biz.activity.GlueActivity;
import com.poscoict.glueframework.biz.control.GlueBizControlConstants;
import com.poscoict.glueframework.context.GlueContext;
import com.poscoict.glueframework.dao.jdbc.GlueGenericJdbcDao;
import com.poscoict.glueframework.dao.manager.GlueQueryDefinition;
import com.poscoict.glueframework.dao.vo.GlueParameter;

public class GetEmpForPageSet extends GlueActivity<GlueContext>
{
    // Do not define the Class Member Variable!!
    public String runActivity( GlueContext ctx )
    {
        GlueGenericJdbcDao dao = (GlueGenericJdbcDao) this.getDao( "biz-dao" );
        GlueQueryDefinition def = dao.getQueryManager().getQueryDefinition( "sample.emp.select" );
        String sql = def.getQueryStatement();
        String countSql = new StringBuilder().append( "select count(*) totalRowCnt from (" ).append( sql ).append( ")" ).toString();
        String pageSql = new StringBuilder().append( "select * from ( select rownum as no, t.* from (" ).append( sql ).append( ") t ) where no > (? * (?-1)) and no <= (? * ?)" ).toString();
        String pageSize = (String)ctx.get( "pageSize" );
        String curPage = (String)ctx.get( "curPage" );

        List<Object> paramList = new ArrayList<Object>();
        paramList.add( "20" );
        List<Map<?,?>> count = dao.findByQueryStatement( countSql, new GlueParameter<List<?>>(paramList) );
        ctx.put( "result_total", count );
        System.out.println("total Row Count : " + count.get( 0 ).get( "totalRowCnt" ));

        paramList.add( pageSize );
        paramList.add( curPage );
        paramList.add( pageSize );
        paramList.add( curPage );
        List<Map<?,?>> page = dao.findByQueryStatement( pageSql, new GlueParameter<List<?>>(paramList) );
        ctx.put( "result", page );
        ctx.put( "result_current", page.size() );

        return GlueBizControlConstants.SUCCESS;
    }
}