package sample.activity;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.poscoict.glueframework.biz.activity.GlueActivity;
import com.poscoict.glueframework.biz.control.GlueBizControlConstants;
import com.poscoict.glueframework.context.GlueContext;
import com.poscoict.glueframework.dao.GlueGenericDao;
import com.poscoict.glueframework.dao.vo.GlueParameter;

public class GetEmpFromEDB extends GlueActivity<GlueContext>
{
    // Do not define the Class Member Variable!!
    public String runActivity( GlueContext ctx )
    {
        GlueGenericDao dao = (GlueGenericDao) this.getDao( "biz-dao" );

        List<Object> paramList = new ArrayList<Object>();
        paramList.add( "10" );
        List<?> result = dao.find( "sample.emp.select", new GlueParameter<List<?>>( paramList ) );
        ctx.put( "result", result );

        Map<String, Object> paramMap = new HashMap<String, Object>();
        paramMap.put( "deptno", "20" );
        List<?> result2 = dao.find( "sample.emp.select.named", new GlueParameter<Map<?, ?>>( paramMap ) );
        ctx.put( "result2", result2 );

        paramList = new ArrayList<Object>();
        paramList.add( "1111" );
        paramList.add( "test" );
        paramList.add( "5000" );
        paramList.add( "10" );
        int cnt = dao.insert( "sample.emp.insert", new GlueParameter<List<?>>( paramList ) );
        this.logger.info( "{}  ", cnt );
        this.commitTransaction( "biz-tx" );

        paramList = new ArrayList<Object>();
        paramList.add( "6000" );
        paramList.add( "TEST" );
        paramList.add( "1111" );
        cnt = dao.update( "sample.emp.update", new GlueParameter<List<?>>( paramList ) );
        this.logger.info( "{}  ", cnt );
        this.commitTransaction( "biz-tx" );

        paramList = new ArrayList<Object>();
        paramList.add( "1111" );
        cnt = dao.delete( "sample.emp.delete", new GlueParameter<List<?>>( paramList ) );
        this.logger.info( "{}  ", cnt );
        this.commitTransaction( "biz-tx" );

        return GlueBizControlConstants.SUCCESS;
    }
}