package sample.activity;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import com.poscoict.glueframework.biz.activity.GlueActivity;
import com.poscoict.glueframework.biz.control.GlueBizControlConstants;
import com.poscoict.glueframework.context.GlueContext;

public class BizLogic extends GlueActivity<GlueContext>
{
    // Do not define the Class Member Variable!!
    public String runActivity( GlueContext ctx )
    {
        String resultKey = null;
        if ( ctx.containsKey( GlueBizControlConstants.JAXWS_RESULT ) )
        {
            resultKey = (String) ctx.get( GlueBizControlConstants.JAXWS_RESULT );
        } else
        {
            resultKey = GlueBizControlConstants.JAXWS_RESULT;
        }

        List<Map<String, String>> empList = (List<Map<String, String>>) ctx.get( "testData2" );
        if ( ctx.containsKey( "deptno" ) )
        {
            String deptno = (String) ctx.get( "deptno" );
            List<Map<String, String>> empListByDeptno = new ArrayList<Map<String, String>>();
            for ( Map<String, String> map : empList )
            {
                if ( map.get( "DEPTNO" ).equals( deptno ) )
                {
                    empListByDeptno.add( map );
                }
            }
            ctx.put( resultKey, empListByDeptno );
        } else if ( ctx.containsKey( "empno" ) )
        {
            String empno = (String) ctx.get( "empno" );
            Map<String, String> emp = null;
            for ( Map<String, String> map : empList )
            {
                if ( map.get( "EMPNO" ).equals( empno ) )
                {
                    emp = map;
                }
            }
            ctx.put( resultKey, emp );
        } else
        {
            ctx.put( resultKey, empList );
        }

        return GlueBizControlConstants.SUCCESS;
    }
}