package sample.activity;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.poscoict.glueframework.biz.activity.GlueActivity;
import com.poscoict.glueframework.biz.control.GlueBizControlConstants;
import com.poscoict.glueframework.context.GlueContext;
import com.poscoict.glueframework.dao.vo.GlueRow;
import com.poscoict.glueframework.dao.vo.GlueRowImpl;
import com.poscoict.glueframework.dao.vo.GlueRowSet;
import com.poscoict.glueframework.dao.vo.GlueRowSetImpl;

public class InitData extends GlueActivity<GlueContext>
{
    @Override
    public String runActivity( GlueContext ctx )
    {
        System.out.println( "ServiceName : " + ctx.get( GlueBizControlConstants.SERVICE_NAME ) );
        System.out.println( "This is '" + this.getName() + "' activity" );
        
        String[][] emps = 
        {   
            {"7782","CLARK","MANAGER","2450","10"},
            {"7839","KING","PRESIDENT","5000","10"},
            {"7934","MILLER","CLERK","1300","10"},
            {"7369","SMITH","CLERK","800","20"},
            {"7566","JONES","MANAGER","2975","20"},
            {"7788","SCOTT","ANALYST","3000","20"},
            {"7876","ADAMS","CLERK","1100","20"},
            {"7902","FORD","ANALYST","3000","20"},
            {"7499","ALLEN","SALESMAN","1600","30"},
            {"7521","WARD","SALESMAN","1250","30"},
            {"7654","MARTIN","SALESMAN","1250","30"},
            {"7698","BLAKE","MANAGER","2850","30"},
            {"7844","TURNER","SALESMAN","1500","30"},
            {"7900","JAMES","CLERK","950","30"},
            {"1111","̼","MANAGER","5000","40"},
            {"2222","縸","MANAGER","5000","40"}
        };
        List<HashMap<String, String>> empList = new ArrayList<HashMap<String,String>>();
        GlueRowSet<GlueRow<String, Object>> rowSet = new GlueRowSetImpl( );
        for ( String[] emp : emps )
        {
            HashMap<String, String> data = new HashMap<String, String>();
            data.put( "EMPNO", emp[0] );
            data.put( "ENAME", emp[1] );
            data.put( "JOB", emp[2] );
            data.put( "SAL", emp[3] );
            data.put( "DEPTNO", emp[4] );
            empList.add( data );

            GlueRow<String, Object> row = new GlueRowImpl();
            row.put( "EMPNO", emp[0] );
            row.put( "ENAME", emp[1] );
            row.put( "JOB", emp[2] );
            row.put( "SAL", emp[3] );
            row.put( "DEPTNO", emp[4] );
            rowSet.add( row );
        }

        ctx.put( "testData2", empList );
        ctx.put( "testData", rowSet );
        return GlueBizControlConstants.SUCCESS;
    }
}