package sample.jaxws;

import java.util.HashMap;
import java.util.List;

import com.poscoict.glueframework.biz.control.GlueBizControlConstants;
import com.poscoict.glueframework.biz.control.GlueBizController;
import com.poscoict.glueframework.biz.control.GlueBizProvider;
import com.poscoict.glueframework.context.GlueContext;
import com.poscoict.glueframework.context.GlueDefaultContext;

public class EmpServiceImpl implements EmpService
{
    @Override
    public List<HashMap<String, String>> findEmpAll() throws Exception
    {
        GlueContext ctx = new GlueDefaultContext();
        ctx.put( GlueBizControlConstants.SERVICE_NAME, "jaxws1-service" );

        GlueBizController bizIf = GlueBizProvider.getController();
        bizIf.doAction( ctx );

        return (List<HashMap<String, String>>) ctx.get( GlueBizControlConstants.JAXWS_RESULT );
    }

    @Override
    public HashMap<String, String> findEmpByEmpno( String id ) throws Exception
    {
        GlueContext ctx = new GlueDefaultContext();
        ctx.put( GlueBizControlConstants.SERVICE_NAME, "jaxws1-service" );
        ctx.put( GlueBizControlConstants.JAXWS_RESULT, "empInfo" );
        ctx.put( "empno", id );

        GlueBizController bizIf = GlueBizProvider.getController();
        bizIf.doAction( ctx );

        return (HashMap<String, String>) ctx.get( "empInfo" );
    }

    @Override
    public String findEnameByEmpno( String id ) throws Exception
    {
        return findEmpByEmpno( id ).get( "ENAME" );
    }
}
