package test;

import org.quartz.CronScheduleBuilder;
import org.quartz.JobBuilder;
import org.quartz.JobDetail;
import org.quartz.JobKey;
import org.quartz.Scheduler;
import org.quartz.SchedulerException;
import org.quartz.SchedulerFactory;
import org.quartz.SimpleScheduleBuilder;
import org.quartz.Trigger;
import org.quartz.TriggerBuilder;
import org.quartz.TriggerKey;
import org.quartz.impl.StdSchedulerFactory;

import sample.job.GlueQuartzJobBean;

public class Test_Scheduler
{

    // http://www.javacodegeeks.com/2012/07/quartz-2-scheduler-example.html
    public static void main( String[] args ) throws SchedulerException
    {
        JobDetail job1 = JobBuilder.newJob( GlueQuartzJobBean.class ).withIdentity( new JobKey( "job-1", "group-G1" ) 
                ).build();
        JobDetail job2 = JobBuilder.newJob( GlueQuartzJobBean.class ).withIdentity( new JobKey( "job-2", "group-G1" ) 
                ).build();
        Trigger simpleTriger = TriggerBuilder.newTrigger().withIdentity( new TriggerKey( "trigger-1", "TG1" )
                ).withSchedule( SimpleScheduleBuilder.simpleSchedule().withIntervalInSeconds( 20 ).repeatForever()
                ).build();
        Trigger cronTriger = TriggerBuilder.newTrigger().withIdentity( new TriggerKey( "trigger-2", "TG1" )
                ).withSchedule( CronScheduleBuilder.cronSchedule( "10 * * * * ?" )
                ).build();
        SchedulerFactory sf = new StdSchedulerFactory();
        Scheduler scheduler = sf.getScheduler();
        // Scheduler will not execute jobs until it has been started (though they
        // can be scheduled before start())
        scheduler.scheduleJob( job1, simpleTriger );
        scheduler.scheduleJob( job2, cronTriger );

        scheduler.start();
    }
}
